/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/
// VICreator.h: interface of the CVICreator class
//
//////////////////////////////////////////////////////////////////////

#ifndef __VI_CREATOR_H__
#define __VI_CREATOR_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef DATAPROCESS_EXPORTS
#define DATAPROCESS_API __declspec(dllexport)
#else
#define DATAPROCESS_API __declspec(dllimport)
#endif


#include <VISensorRawData.h>
#include <VISensorRawDataList.h>
#include <VISensorDataProcess.h>
#include <VISensorRawFileProcess.h>
#include <VISensorPolygonFileProcess.h>
#include <VISensorStageRegistTool.h>
DATAPROCESS_API CVISensorRawData*               VISensorRawDataCreate(int nSensorType)  ;
DATAPROCESS_API CVISensorRawDataList*           VISensorRawDataListCreate(int nSensorType)  ;
DATAPROCESS_API CVISensorDataProcess*           VISensorDataProcessCreate(int nSensorType)  ;
DATAPROCESS_API CVISensorRawFileProcess*        VISensorRawFileProcessCreate(int nSensorType)     ;
DATAPROCESS_API CVISensorPolygonFileProcess*    VISensorPolygonFileProcessCreate(int nSensorType);
DATAPROCESS_API CVISensorStageRegistTool*       VISensorStageRegistToolCreate(int nSensorType)      ;
DATAPROCESS_API BOOL VISensorRawDataCopy(const CVISensorRawData* pSrcRawData,CVISensorRawData* pDestRawData,int nSensorType);

DATAPROCESS_API void							VISensorRawDataDelete(CVISensorRawData* pRawData)  ;
DATAPROCESS_API void							VISensorRawDataListDelete(CVISensorRawDataList* pRawDataList)  ;
DATAPROCESS_API void							VISensorDataProcessDelete(CVISensorDataProcess* pDataProcess);
DATAPROCESS_API void							VISensorRawFileProcessDelete(CVISensorRawFileProcess* pRawFileProcess);
DATAPROCESS_API void 							VISensorPolygonFileProcessDelete(CVISensorPolygonFileProcess* pPolygonFileProcess);
DATAPROCESS_API void							VISensorStageRegistToolDelete(CVISensorStageRegistTool* pStageRegistTool);
#endif
