/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#include <CVIVector.h>


#ifndef _VVDII_TYPES_H
#define	_VVDII_TYPES_H

typedef int	    		VVD_Int;
typedef short	    	VVD_Short;
typedef char	    	VVD_Char;
typedef float	    	VVD_Float;
typedef double	    	VVD_Double;
typedef unsigned long	VVD_Ulong;
typedef unsigned short	VVD_Ushort;
typedef unsigned char	VVD_Uchar;

typedef VVD_Int	    	VVD_Flag;

typedef	CVIVector_2<double>	    CVIDbl2dPoint;
typedef	CVIVector_3<double>	    CVIDbl3dPoint;
typedef CVIVector_3<float>      CVIDbl3fPoint;

typedef	CVIDbl3dPoint		VICOORD3D   ;
typedef	CVIDbl3dPoint		VIVECTOR3D  ;
typedef	CVIDbl2dPoint		VICOORD2D   ;
typedef CVIDbl3fPoint       VIVECTOR3F  ;

typedef	VIVECTOR3D  VVDII_Point3;
typedef VIVECTOR3F  VVD_Point3;

typedef	struct
{
	VICOORD3D		point;
}VIVERTEX;

#define VI_INVALID_DATA    -999.0
#define VI_INVALID_DATA_3D -999999.0

#define		M_PI			3.14159265358979323846264338327950

/* 3D vector */
typedef VVD_Point3 VVD_Vector3;

// Sensor Type
#define VI_VIVID9i_SENSOR   1
#define VI_VIVIDLSI_SENSOR	2
#define VI_VIVID9iBT_SENSOR	3
#define VI_VIVID910_SENSOR	4	// SEEDS 06/05

#endif
