/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/
#pragma once

class CVISensor;
class CVivid9iPara;
class CVvdImage;
class CVivid9iCalibErr;

class CVISensorPara;

class CVivid9iControl
{
public:
    CVivid9iControl(void);
    virtual ~CVivid9iControl(void);
protected:
    CVISensor*      m_pSensor   ;
    int             m_nErrCode  ;

	CVISensorPara*	m_pSensorPara;
	int				m_nVividType;

public:
    virtual BOOL DoScan(void);
    virtual void SetErrCode(int nErrCode);
    virtual BOOL SaveRawData(void);
    virtual BOOL SavePolygonData(void);
    virtual int GetErrCode(void);
    virtual BOOL SaveASCIIData(void);
    virtual BOOL GetMonitorData(CVvdImage& ImageData,const BOOL bLog,const BOOL bDark);
    virtual BOOL GetColorData(CVvdImage& ImageData,const BOOL bLog,const BOOL bDark);
    virtual BOOL DoCalibration(void);

	int		GetVividType() { return m_nVividType; }
	BOOL	SetVividType(int nType);
};
