/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/
// Make3DUtil.h: CMake3DUtil NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAKE3DUTIL_H__89EC7373_300B_4189_97B8_4C011D5FA84A__INCLUDED_)
#define AFX_MAKE3DUTIL_H__89EC7373_300B_4189_97B8_4C011D5FA84A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <VividIITypes.h>   //AK@040602
#include <VIVertexData.h>   //AK@040324
struct	IMAGE   //{̓NXɂׂ AK@030924
{
	int				width;
	int				height;
	unsigned char*	image;
	int				size;

	IMAGE() { width = 0; height = 0; image = NULL; size = 0; }
	~IMAGE(){ DeleteImage(); }

	void		DeleteImage()
	{
		if( image )		delete[] image;
		size	= 0;
		image	= NULL;
	}

	BOOL		AllocateImage( int n )
	{
		if( n <= size )	return	TRUE;
		DeleteImage();
		
		size = ( ( n + 15 ) >> 4 ) << 4;
		image = new unsigned char[ size ];
		if( image == NULL )	size = 0;
		return	size != 0;
	}
};


/* xf[^ */
struct CamLabel
{
    int numPoints;
    int index;
};

struct CamLabelList
{
    int numLabels;
    CamLabel *label;

	CamLabelList() { numLabels=0; label=NULL;}
	~CamLabelList() { DeleteLabel();}

	void DeleteLabel() {
						if(label)
							delete [] label;
						label = NULL;
	}

	BOOL AllocLabel(int n) {
					if(label)
						delete [] label;
					label = new CamLabel[n];
					if(!label)
						return FALSE;
					return TRUE;
	}

};  //AK@030924(NXɂKv)

/*-----------------------------------------------------------------------------
  ʎ  a*x + b*y + c*z = d
    //AK@040325
----------------------------------------------------------------------------*/
typedef struct {
    double a;
    double b;
    double c;
    double d;
} PLANE;


void CalcNormalVertex(const VIVERTEX *vtx1, const VIVERTEX *vtx2, const VIVERTEX *vtx3, VIVERTEX *nvtx);//AK@031127
void MakeFillHoleMask(IMAGE *mask);
BOOL FillByMask(float *grav, IMAGE *mask);//KM@040617

BOOL CalcNoiseFilter(int width,int height,float *grav);//KM@040617BOOL

//AK@020320 fBAtB^̃f[^ۑ\̒`

#define MEDIAN_WIDTH    3
#define MEDIAN_HEIGHT   3

#define INVECTOR(p,q)  ((p)->x * (q)->x + (p)->y * (q)->y + (p)->z * (q)->z)

void outvect(VICOORD3D *a, VICOORD3D *b, VICOORD3D *c);

typedef struct 
{
	VICOORD3D	startpoint;
	VIVECTOR3D	direction;
}VLINE;

typedef struct {
    int filter[MEDIAN_HEIGHT][MEDIAN_WIDTH]; 
    int filter_size ;                          //fBAtB^vZvf̌
    int center_idx ;                            //l̃CfbNX
}MedianData;

float CalcMedian(float *grav,MedianData *Median,float **temp_grav, int x,int y);
void CalcMedianFilter(int width,int height,float *grav,MedianData *Median,float **temp_grav);//AK@020513 ύX
int	CamLabeling(IMAGE *mask, IMAGE *timage);
void CamCountLabel(IMAGE *limage, CamLabelList *labellist);

//AK@040324-->
void MakeMaskImageFromVertexData(IMAGE *mask,CVIVertexData& VertexData);     //AK@040324(`[gׂ̈ɒǉj
void SmoothVertexData(CVIVertexData& Targetdata, CVIVertexData& Smoothdata);//AK@040324(`[gׂ̈ɒǉj
BOOL ShrinkCam(IMAGE *mask);//KM@040617
BOOL ExpandCam(IMAGE *mask);//KM@040617
void DeleteVertexDataByMask(CVIVertexData& Targetdata, IMAGE *mask);
void CalcNormalData(CVIVertexData& TargetVertex, CVIVertexData& NormalVertex);
void NormalPlaneMask(CVIVertexData& TargetData, IMAGE *mask);
void planeMask(const IMAGE* mask, const IMAGE* cosimg,const int pindex, IMAGE* pmask, const int wd);
void makeNormalCos(CVIVertexData&  NormalData, const VIVECTOR3D* v1, IMAGE* cosimg);
void makeHistData(IMAGE *cosimg, int *hist);
int	getPeakIndex(const int *hist, const int minid, const int maxid);
BOOL checkHistBalance(const int *hist, const int p1, const int p2);
BOOL getPlaneWithMask(CVIVertexData& TargetVertex, IMAGE *pmask, PLANE *plane);
static BOOL	CalcPlane(VICOORD3D *axs,int n,PLANE *plane);
static BOOL jaco(double *a, double *u,double *k,int n);
void CalcPoleYRotateMatrix(double *mtx, VLINE *pole, double rotation);
void CalcPoleTransfer(VIVECTOR3D *pole, double *r);
static void Y_Rotation(double rot, double *r);
void AxB(double *a, double *b, double *c, int n);

//AK@040324<--
//AK@050526-->
void ExecSmoothBrightnessStep(float *grav,
						  DWORD* sumKido,
						  int width,
						  int height)   ;
float MedianFilter3x3(float **temp_grav, int x,int y);
float AverageFilter(float **temp_grav, int x,int y,int mask_size);
float LeeSigmaFilter(float **temp_grav, int x,int y, float W,int mask_size);
//AK@050526<--


class CMake3DUtil  
{
public:
	CMake3DUtil();
	virtual ~CMake3DUtil();

};

#endif // !defined(AFX_MAKE3DUTIL_H__89EC7373_300B_4189_97B8_4C011D5FA84A__INCLUDED_)
